/* This file is part of Lemma, a geophysical modelling and inversion API.
 * More information is available at http://lemmasoftware.org
 */

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

/**
 * @file
 * @date      05/03/2018 09:44:21 AM
 * @version   $Id$
 * @author    Trevor Irons (ti)
 * @email     tirons@egi.utah.edu
 * @copyright Copyright (c) 2018, University of Utah
 * @copyright Copyright (c) 2018, Lemma Software, LLC
 */

#include "FHT.h"
using namespace Lemma;

int main() {
//    std::cout << "FHT test" << std::endl;
    auto fht = FHT< FHTKEY201 >::NewSP();
    std::cout << *fht << std::endl;
    std::cout << fht->GetABSER() << std::endl;

    auto fht1 = FHT< FHTKEY101 >::NewSP();
    std::cout << *fht1 << std::endl;
    std::cout << fht1->GetABSER() << std::endl;

    //auto fhtq = FHT< QWEKEY >::NewSP();
}
